---
title: Firefox Developer Tools
slug: Tools
tags:
  - DevTools
  - Developing Mozilla
  - Guide
  - Tools
  - Web Development
  - 'Web Development:Tools'
  - 'l10n:priority'
---
<div>{{ToolsSidebar}}</div>

<p class="summary">Firefox Developer Tools is a set of web developer tools built into Firefox. You can use them to examine, edit, and debug HTML, CSS, and JavaScript.</p>

<p>This section contains detailed guides to all of the tools as well as information on how to debug Firefox for Android, how to extend DevTools, and how to debug the browser as a whole.</p>

<p>If you have any feedback on DevTools or want to contribute to the project, you can <a href="https://firefox-dev.tools/">join the DevTools community</a>.</p>

<div class="note">
<p><strong>Note</strong>: If you are just getting started with web development and using developer tools, our <a href="/en-US/docs/Learn">learning</a> docs will help you — see <a href="/en-US/docs/Learn/Getting_started_with_the_web">Getting started with the Web</a> and <a href="/en-US/docs/Learn/Common_questions/What_are_browser_developer_tools">What are browser developer tools?</a> for good starting points.</p>
</div>

<h2 id="The_Core_Tools">The Core Tools</h2>

<p>You can open the Firefox Developer Tools from the menu by selecting <em>Tools</em> &gt; <em>Web Developer</em> &gt; <em>Toggle Tools</em> or use the keyboard shortcut  <kbd>Ctrl</kbd> + <kbd>Shift</kbd> + <kbd>I</kbd> or <kbd>F12</kbd> on Windows and Linux, or <kbd>Cmd</kbd> + <kbd>Opt</kbd> + <kbd>I</kbd> on macOS.</p>

<p>The ellipsis menu on the right-hand side of Developer Tools contains several commands that let you perform actions or change tool settings.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16087/DevTools_LayoutMenu.png" style="display: block; height: 290px; margin: 0 auto; width: 225px;"></p>

<table class="standard-table" style="height: 178px; width: 840px;">
 <tbody>
  <tr>
   <td><img alt="" src="https://mdn.mozillademos.org/files/16092/iframe_button.png" style="height: 69px; width: 69px;"></td>
   <td>This button only appears when there are multiple iframes on a page. Click it to display a list of the iframes on the current page and select the one with which you want to work.</td>
  </tr>
  <tr>
   <td><img alt="" src="https://mdn.mozillademos.org/files/16088/camera_button.png" style="height: 69px; width: 69px;"></td>
   <td>Click this button to take a screenshot of the current page. (<strong>Note:</strong> This feature is not turned on by default and must be enabled in settings before the icon will appear.)</td>
  </tr>
  <tr>
   <td><img alt="" src="https://mdn.mozillademos.org/files/16089/responsive_button.png" style="height: 69px; width: 69px;"></td>
   <td>Toggles Responsive Design Mode.</td>
  </tr>
  <tr>
   <td><img alt="" src="https://mdn.mozillademos.org/files/16090/menu_button.png" style="height: 69px; width: 69px;"></td>
   <td>Opens the menu that includes docking options, the ability to show or hide the split console, and Developer Tools settings. The menu also includes links to the documentation for Firefox Web Tools and the Mozilla Community.</td>
  </tr>
  <tr>
   <td><img alt="" src="https://mdn.mozillademos.org/files/16091/close_button.png" style="height: 69px; width: 69px;"></td>
   <td>Closes the Developer Tools</td>
  </tr>
 </tbody>
</table>

<div class="column-container">
<div class="column-half">
<h3 id="Page_Inspector">Page Inspector</h3>

<p><a href="/en-US/docs/Tools/Page_Inspector"><img alt="The all-new Inspector panel in Firefox 57." src="https://mdn.mozillademos.org/files/16371/landingPage_PageInspector.png" style="border: 1px solid black; display: block; height: 171px; margin-left: auto; margin-right: auto; width: 425px;"></a></p>

<p>View and edit page content and layout. Visualize many aspects of the page including the box model, animations, and grid layouts.</p>
</div>

<div class="column-half">
<h3 id="Web_Console">Web Console</h3>

<p><a href="/en-US/docs/Tools/Web_Console"><img alt="The all-new Console in Firefox 57." src="https://mdn.mozillademos.org/files/16368/landingPage_Console.png" style="border: 1px solid black; display: block; height: 403px; margin-left: auto; margin-right: auto; width: 425px;"></a></p>

<p>See messages logged by a web page and interact with the page using JavaScript.</p>
</div>
</div>

<div class="column-container">
<div class="column-half">
<h3 id="JavaScript_Debugger">JavaScript Debugger</h3>

<p><a href="/en-US/docs/Tools/Debugger"><img alt="The all-new Firefox 57 Debugger.html" src="https://mdn.mozillademos.org/files/16369/landingPage_Debugger.png" style="border: 1px solid black; display: block; height: 403px; margin-left: auto; margin-right: auto; width: 425px;"></a></p>

<p>Stop, step through, examine, and modify the JavaScript running on a page.</p>
</div>

<div class="column-half">
<h3 id="Network_Monitor">Network Monitor</h3>

<p><a href="/en-US/docs/Tools/Network_Monitor"><img alt="The Network panel in Firefox 57 DevTools." src="https://mdn.mozillademos.org/files/16370/landingPage_Network.png" style="border: 1px solid black; display: block; height: 403px; margin-left: auto; margin-right: auto; width: 425px;"></a></p>

<p>See the network requests made when a page is loaded.</p>
</div>
</div>

<div class="column-container">
<div class="column-half">
<h3 id="Performance_Tools">Performance Tools</h3>

<p><a href="/en-US/docs/Tools/Performance"><img alt="Performance Tools in Firefox 57 Developer Tools" src="https://mdn.mozillademos.org/files/16372/landingPage_Performance.png" style="border: 1px solid black; display: block; height: 403px; margin-left: auto; margin-right: auto; width: 425px;"></a></p>

<p>Analyze your site's general responsiveness, JavaScript, and layout performance.</p>
</div>

<div class="column-half">
<h3 id="Responsive_Design_Mode">Responsive Design Mode</h3>

<p><a href="/en-US/docs/Tools/Responsive_Design_Mode"><img alt="Responsive Design mode in Firefox 57." src="https://mdn.mozillademos.org/files/16373/landingPage_ResponsiveDesign.png" style="border-style: solid; border-width: 1px; display: block; height: 865px; margin-left: auto; margin-right: auto; width: 425px;"></a></p>

<p>See how your website or app will look and behave on different devices and network types.</p>
</div>
</div>

<div class="column-container">
<div class="column-half">
<h3 id="Accessibility_inspector">Accessibility inspector</h3>

<p><a href="/en-US/docs/Tools/Accessibility_inspector"><img alt="Performance Tools in Firefox 57 Developer Tools" src="https://mdn.mozillademos.org/files/16367/landingPage_Accessibility.png" style="border-style: solid; border-width: 1px; border: 1px solid black; display: block; height: 403px; margin-left: auto; margin-right: auto; width: 425px;"></a></p>

<p>Provides a means to access the page's accessibility tree, allowing you to check what's missing or otherwise needs attention.</p>
</div>

<div class="column-half">
<h3 id="Application_panel">Application panel</h3>

<p><a href="/en-US/docs/Tools/Application"><img alt="Performance Tools in Firefox 57 Developer Tools" src="https://mdn.mozillademos.org/files/17307/just-application-panel.jpg" style="border: 1px solid black; display: block; height: 162px; margin-left: auto; margin-right: auto; width: 425px;"></a></p>

<p>Provides tools for inspecting and debugging modern web apps (also known as <a href="/en-US/docs/Web/Progressive_web_apps">Progressive Web Apps</a>). This includes inspection of <a href="/en-US/docs/Web/API/Service_Worker_API">service workers</a> and <a href="/en-US/docs/Web/Manifest">web app manifests</a>.</p>
</div>
</div>

<div class="note">
<p><strong>Note</strong>: The collective term for the UI inside which the DevTools all live is the <a href="/en-US/docs/Tools/Tools_Toolbox">Toolbox</a>.</p>
</div>

<h2 id="More_Tools">More Tools</h2>

<p>These developer tools are also built into Firefox. Unlike the "Core Tools" above, you might not use them every day.</p>

<div class="twocolumns">
<dl>
 <dt><a href="/en-US/docs/Tools/Memory">Memory</a></dt>
 <dd>Figure out which objects are keeping memory in use.</dd>
 <dt><a href="/en-US/docs/Tools/Storage_Inspector">Storage Inspector</a></dt>
 <dd>Inspect cookies, local storage, indexedDB, and session storage present in a page.</dd>
 <dt><a href="/en-US/docs/Tools/DOM_Property_Viewer">DOM Property Viewer</a></dt>
 <dd>Inspect the page's DOM properties, functions, etc.</dd>
 <dt><a href="/en-US/docs/Tools/Eyedropper">Eyedropper</a></dt>
 <dd>Select a color from the page.</dd>
 <dt><a href="/en-US/docs/Tools/Style_Editor">Style Editor</a></dt>
 <dd>View and edit CSS styles for the current page.</dd>
 <dt><a href="/en-US/docs/Tools/Screenshot_tool">Taking screenshots</a></dt>
 <dd>Take a screenshot of the entire page or of a single element.</dd>
 <dt><a href="/en-US/docs/Tools/Measure_a_portion_of_the_page">Measure a portion of the page</a></dt>
 <dd>Measure a specific area of a web page.</dd>
 <dt><a href="/en-US/docs/Tools/Rulers">Rulers</a></dt>
 <dd>Overlay horizontal and vertical rulers on a web page</dd>
</dl>
</div>

<div class="column-container">
<div class="column-third">
<p><img alt="" src="https://mdn.mozillademos.org/files/15588/logo-developer-quantum.png" style="display: block; margin: 0px auto;"></p>

<p style="text-align: center;">For the latest developer tools and features, try Firefox Developer Edition.</p>

<p><a href="https://www.mozilla.org/en-US/firefox/developer/">Download Firefox Developer Edition</a></p>
</div>

<div class="column-third"></div>
</div>

<h2 id="Connecting_the_Developer_Tools">Connecting the Developer Tools</h2>

<p>If you open the developer tools using <a href="/en-US/docs/Tools/Keyboard_shortcuts#Opening_and_closing_tools">keyboard shortcuts</a> or the equivalent menu items, they'll target the document hosted by the currently active tab. But you can attach the tools to a variety of other targets, too, both within the current browser and in different browsers or even different devices.</p>

<div class="twocolumns">
<dl>
 <dt><a href="/en-US/docs/Tools/about:debugging">about:debugging</a></dt>
 <dd>Debug add-ons, content tabs, and workers running in the browser.</dd>
 <dt><a href="/en-US/docs/Tools/Remote_Debugging/Debugging_Firefox_for_Android_over_Wifi">Connecting to Firefox for Android</a></dt>
 <dd>Connect the developer tools to an instance of Firefox running on an Android device.</dd>
 <dt><a href="/en-US/docs/Tools/Working_with_iframes">Connecting to iframes</a></dt>
 <dd>Connect the developer tools to a specific iframe in the current page.</dd>
 <dt><a href="/en-US/docs/Tools/Valence">Connecting to other browsers</a></dt>
 <dd>Connect the developer tools to Chrome on Android and Safari on iOS.</dd>
</dl>
</div>

<h2 id="Debugging_the_browser">Debugging the browser</h2>

<p>By default, the developer tools are attached to a web page or web app. But you can also connect them to the browser as a whole. This is useful for browser and add-on development.</p>

<div class="twocolumns">
<dl>
 <dt><a href="/en-US/docs/Tools/Browser_Console">Browser Console</a></dt>
 <dd>See messages logged by the browser itself and by add-ons, and run JavaScript code in the browser's scope.</dd>
 <dt><a href="/en-US/docs/Tools/Browser_Toolbox">Browser Toolbox</a></dt>
 <dd>Attach the Developer Tools to the browser itself.</dd>
</dl>
</div>

<h2 id="Extending_DevTools">Extending DevTools</h2>

<p>For information on extending the Firefox DevTools, see <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions/Extending_the_developer_tools">Extending the developer tools</a> over in the <a href="/en-US/docs/Mozilla/Add-ons/WebExtensions">Browser Extensions</a> section of MDN.</p>

<h2 id="Migrating_from_Firebug">Migrating from Firebug</h2>

<p>Firebug has come to the end of its lifespan (see <a href="https://hacks.mozilla.org/2016/12/firebug-lives-on-in-firefox-devtools/">Firebug lives on in Firefox DevTools</a> for details of why), and we appreciate that some people will find migrating to another less familiar set of DevTools to be challenging. To ease a transition from Firebug to the Firefox developer tools, we have written a handy guide — <a href="/en-US/docs/Tools/Migrating_from_Firebug">Migrating from Firebug</a>.</p>

<h2 id="Contribute">Contribute</h2>

<p>If you want to help improve the developer tools, these resources will get you started.</p>

<div class="twocolumns">
<dl>
 <dt><a href="https://firefox-dev.tools/">Get Involved</a></dt>
 <dd>Our community website explains how to get involved.</dd>
 <dt><a href="http://bugs.firefox-dev.tools/">bugs.firefox-dev.tools</a></dt>
 <dd>A tool helping to find bugs to work on.</dd>
</dl>
</div>
